<html>
    <head>
        <title>Zymeworks Interview Solution</title>
        <script src="js/chart-new.js"></script>
        <script src="js/jquery2.1.1.min.js"></script>
        <style>
        </style>
    </head>
    <body>
    <div style="width: 1200px; margin: 0px auto;">
        <canvas id="chart" width="1200" height="400"></canvas>
        <div id="key1"></div>
        <div id="key2"></div>
    </div>

    <script>
    var jsonData = {};
    var files = ['data1', 'data2'];

    // map file parsing AJAX calls to files array
    var getFiles = $.map(
        files,
        function (f) { 
            return $.getJSON('data/' + f + '.json', function (data) {
                jsonData[f] = data;
            });
        }
    );
    $.when
    .apply(null,getFiles)
    .then(function () { 
        // only proceed when AJAX calls complete.
        console.log('jsonData:', jsonData);
        var group1 = jsonData.data1;
        var group2 = jsonData.data2;

        getScale = function (rawData) {
            /*
            Function for determining scale.
            First row assumed to contain scale,
            scales is assumed to be consistent across samples
            and integer based.
            */
            scale = [];
            for (key in rawData[0]) {
                if (!isNaN(parseInt(key))) {
                    scale.push(key);
                }
            }
            return scale;
        };

        getValues = function (row) {
            /*
            Function for generating title, values
            obj. Keys which cannot be parsed to integers
            are assumed to be the dataset title.
            */
            var obj = {values: [], title: ''};
            for (key in row) {
                var value = row[key];
                if (!isNaN(parseInt(key))) {
                    // empty values are treated as 0 by default
                    // so we can set them to undefined to avoid 
                    // rendering as a data point.
                    if (value == '') value = undefined;
                    obj.values.push(value);
                } else {
                    obj.title = value;
                }
            }
            return obj;
        };

        getLines = function (rawData, color) {
            /*
            Function for generating line objects
            to be used by chart.js
            */
            var lines = [];
            for (i=0;i<rawData.length;i++) {
                var obj;
                var row = rawData[i];
                obj = getValues(row);
                // this is the chart.js line object
                lineObj = {
                    fillColor : "rgba(220,220,220,0.0)",
                    fillOpacity: 0.0,
                    strokeColor : color,
                    pointColor : color,
                    pointStrokeColor : "#fff",
                    data : obj.values,
                    title : obj.title
                };
                lines.push(lineObj);
            };
            // a series of line objects
            return lines;
        };

        // set color variables
        var colorGroup1 = "rgba(81,120,159,0.9)";
        var colorGroup2 = "rgba(225,137,335,0.9)";

        // get scale (known to be consistent for all samples)
        var scale = getScale(group1);
        var linesGroup1 = getLines(group1, colorGroup1);
        var linesGroup2 = getLines(group2, colorGroup2);
        var lines = [];
        lines = linesGroup1.concat(linesGroup2);

        // generate data object for chart
        var data = {
            labels : scale,
            datasets : lines
        };

        // chart options
        var options = {
            graphTitle : "Zymeworks Data Interview",
            legend : false,xAxisLabel : "",
            yAxisLabel : "Body Weight",
            yAxisUnit : "g",
            xAxisLabel : "Time (days)",
            annotateDisplay : true,
            pointDotRadius : 1,
            pointDot : false,
            datasetStrokeWidth : 1
        }

        // new chart instance
        var ctx = $("#chart").get(0).getContext("2d");
        new Chart(ctx).Line(data, options);
     
        // add legend keys
        var key1 = $("#key1").css('color', colorGroup1).html('Drug 1 (30 mg/kg)');
        var key2 = $("#key2").css('color', colorGroup2).html('Drug 2 (15 mg/kg)');
    });
    </script>

    </body>
</html>